/*
    Valtra Tractors
    Copyright 2004 Martin Storsj

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Martin Storsj
    martin@martin.st
*/

#ifndef __BUTTON_H
#define __BUTTON_H


#include <SDL.h>
#include <vector>
#include <SDL_ttf.h>
#include "point.h"
#include "sprites.h"

using std::vector;

typedef vector<bool> bvector;


class Button {
private:
	bvector clickmap;
public:
	Button();
	~Button();
	SDL_Rect r;
	void setPos(int x, int y);
	SDL_Surface *surf[3];
	void setSurf(SDL_Surface *s1, SDL_Surface *s2, SDL_Surface *s3);
	void setClickOffset(int x, int y);
	bool freeSurfaces;
	void setClickmap(SDL_Surface *surf);
	bool isClickable(int x, int y);
	IPoint offset[3];
	IPoint imgOffset[3];
	SDL_Surface *content;
	const char *text;
	IPoint contOffset, textOffset;
	void setText(const char *text);
	void setText(const char *text, int x, int y, TTF_Font *font);
	TTF_Font *font;
	SDL_Color textColor;
	int state, laststate;
	int ids[3];
	void getIds(SpriteEngine *se);
	void addSprites(SpriteEngine *se);
	void updateSprites(SpriteEngine *se);
	void doneDrawing(SpriteEngine *se);
};



#endif
